mod player;

use godot::prelude::*;

struct MyExtension;

// #[gdextension]
// unsafe impl ExtensionLibrary for MyExtension {}

unsafe impl ExtensionLibrary for MyExtension {}
// #[cfg(target_os = "emscripten")]
#[inline(always)]
fn emscripten_preregistration() {
    let script = b"var pkgName = \'hello_gdext\';\n                console.log(\"[DEBUG] Reached point A.\");\n                var libName = pkgName.replaceAll(\'-\', \'_\') + \'.wasm\';\n                console.log(\"[DEBUG] Reached point B.\");\n                var dso = LDSO.loadedLibsByName[libName];\n                // This property was renamed as of emscripten 3.1.34\n                var dso_exports = \"module\" in dso ? dso[\"module\"] : dso[\"exports\"];\n                var registrants = [];\n                console.log(\"[DEBUG] Reached point C.\");\n                for (sym in dso_exports) {\n                    console.log(`[DEBUG] Let\'s check this symbol \'${sym}\'...`);\n                    if (sym.startsWith(\"dynCall_\") || sym.startsWith(\"invoke_\")) {\n                        console.log(\"[DEBUG] It is special...\");\n                        if (!(sym in Module)) {\n                            console.log(`Patching Module with ${sym}`);\n                            Module[sym] = dso_exports[sym];\n                        }\n                    } else if (sym.startsWith(\"rust_gdext_registrant_\")) {\n                        registrants.push(sym);\n                        console.log(\"[DEBUG] Pushed one.\");\n                    }\n                }\n                for (sym of registrants) {\n                    console.log(`Running registrant ${sym}`);\n                    dso_exports[sym]();\n                }\n                console.log(\"Added\",  registrants.length, \"plugins to registry!\");\n            \0";
    extern "C" {
        fn emscripten_run_script(script: *const std::ffi::c_char);
    }
    unsafe {
        emscripten_run_script(script as *const _ as *const std::ffi::c_char);
    }
}
#[no_mangle]
unsafe extern "C" fn gdext_rust_init(
    interface_or_get_proc_address: ::godot::sys::InitCompat,
    library: ::godot::sys::GDExtensionClassLibraryPtr,
    init: *mut ::godot::sys::GDExtensionInitialization,
) -> ::godot::sys::GDExtensionBool {
    #[cfg(target_os = "emscripten")]
    {
        let script = b"var pkgName = \'hello_gdext\';\n                console.log(\"[DEBUG] Reached point A.\");\n                var libName = pkgName.replaceAll(\'-\', \'_\') + \'.wasm\';\n                console.log(\"[DEBUG] Reached point B.\");\n                var dso = LDSO.loadedLibsByName[libName];\n                // This property was renamed as of emscripten 3.1.34\n                var dso_exports = \"module\" in dso ? dso[\"module\"] : dso[\"exports\"];\n                var registrants = [];\n                console.log(\"[DEBUG] Reached point C.\");\n                for (sym in dso_exports) {\n                    console.log(`[DEBUG] Let\'s check this symbol \'${sym}\'...`);\n                    if (sym.startsWith(\"dynCall_\") || sym.startsWith(\"invoke_\")) {\n                        console.log(\"[DEBUG] It is special...\");\n                        if (!(sym in Module)) {\n                            console.log(`Patching Module with ${sym}`);\n                            Module[sym] = dso_exports[sym];\n                        }\n                    } else if (sym.startsWith(\"rust_gdext_registrant_\")) {\n                        registrants.push(sym);\n                        console.log(\"[DEBUG] Pushed one.\");\n                    }\n                }\n                for (sym of registrants) {\n                    console.log(`Running registrant ${sym}`);\n                    dso_exports[sym]();\n                }\n                console.log(\"Added\",  registrants.length, \"plugins to registry!\");\n            \0";
        extern "C" {
            fn emscripten_run_script(script: *const std::ffi::c_char);
        }
        unsafe {
            emscripten_run_script(script as *const _ as *const std::ffi::c_char);
        }
    }
    // emscripten_preregistration();
    ::godot::init::__gdext_load_library::<MyExtension>(interface_or_get_proc_address, library, init)
}
fn __static_type_check() {
    let _unused: ::godot::sys::GDExtensionInitializationFunction = Some(gdext_rust_init);
}
#[no_mangle]
#[doc(hidden)]
#[cfg(target_os = "linux")]
pub unsafe extern "C" fn __cxa_thread_atexit_impl(
    func: *mut ::std::ffi::c_void,
    obj: *mut ::std::ffi::c_void,
    dso_symbol: *mut ::std::ffi::c_void,
) {
    ::godot::sys::linux_reload_workaround::thread_atexit(func, obj, dso_symbol);
}
